// (c) 2022 cepstrum.co.jp
// This is not free software.

#include <stdint.h>

#include "c2blas.h"

#define MU          0.00003
#define LMSLEN      4000
#define NOISE_LEVEL 0.1
#define POWER_BETA  0.9995

float w[LMSLEN];
float xbuf[LMSLEN*2];

float* w_ptr   =&w[0];
float* xbuf_ptr=&xbuf[0];

//-------------------------------------------------------

int pn_xorshift(void) {
  static uint64_t y=0x60356f936267ee53;

  y^=(y<<3);
  y^=(y>>43);
  y^=(y<<11);
  return 2*(int)(y%2)-1;
}

//-------------------------------------------------------

void c_routine(float c_ad, float *c_da, unsigned init) {
  static float   power=100.0;
  static int64_t fir_ix;
  float    x;
  float    y;
  float    d;
  float    e;
  unsigned i;

  if (init==1) {
    init=0;
    for (i=0; i<LMSLEN; i=i+1) {
      xbuf[i]=0.0;
      xbuf[i+LMSLEN]=0.0;
      w[i]=0.0;
    }
    fir_ix=0;
  } else {
    x=NOISE_LEVEL*pn_xorshift();
    *c_da=x;
    d=c_ad;
    y=c2blas_fir(x, xbuf, w, LMSLEN, &fir_ix);
    e=d-y;
    power=POWER_BETA*power+(1.0-POWER_BETA)*x*x;
    c2blas_lms(w, 2.0*MU*e/power, xbuf, LMSLEN, fir_ix);
  }

}

